//
if (window.com == null) window.com = {}
//
com.paragon = {}
//
com.paragon.C = {}
com.paragon.C.attr = {
    _prefix: "shdd-",
    onclick: "onclick",
    cref: "cref",
    hl: "hl",
    entry_label: "entry_label",
    spec: "spec",
}
com.paragon.C.props = {
    _prefix: "_shdd:",
    bg: "bg",
    hl: "hl",
    is_auto_scrolled_first_time: "is_auto_scrolled_first_time",
}
com.paragon.C.dom = {
    touchstart: "touchstart",
    touchend: "touchend",
    touchcancel: "touchcancel",
    touchmove: "touchmove",
    click: "click",
}
com.paragon.C.css = {
    background_color: "background-color",
}
//
com.paragon.event = {}
com.paragon.event.EventProcessor = function() {

    var touchestartElement = null;

    this.listen = function(b) {
        if (b) {
            addListeners();
        } else {
            removeListeners();
        }
    }

    function addListeners() {
        document.addEventListener(com.paragon.C.dom.touchstart, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchend, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchcancel, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchmove, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.click, handleEvent, false);
    }
    function removeListeners() {
        document.removeEventListener(com.paragon.C.dom.touchstart, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchend, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchcancel, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchmove, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.click, handleEvent, handleEvent, false);
    }
    function handleEvent(e) {
        if (touchestartElement != null) {
            highlightElement(touchestartElement, false);
            touchestartElement = null;
        }
        if (e.target == document.body || e.target == document.documentElement) return;
        var el = detectClickableElement(e.target);
        if (el == null) {
            if (e.type == com.paragon.C.dom.click)
                findShowHide(e);
            return;
        }
        if (e.type == com.paragon.C.dom.touchstart) {
            touchestartElement = el;
            highlightElement(touchestartElement, true);
        } else if (e.type == com.paragon.C.dom.click) {
            if (el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick)) {
                eval(el.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick));
            } else {
            	Android.translate(getTextContentExceptScript(el), detectSpanElement(e.target).getAttribute("class").toLowerCase());		
            }
        }
    }
    function highlightElement(el, b) {
        if (b) {
            var hasHighlight = false;
            if (el.firstElementChild != null && el.firstElementChild.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl)) {
                hasHighlight = true;
                el.firstElementChild.removeAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl);
                el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl] = true;
            }
            el[com.paragon.C.props._prefix + com.paragon.C.props.bg] = el.style.getPropertyValue(com.paragon.C.css.background_color) == null ? "" : el.style.getPropertyValue(com.paragon.C.css.background_color);
            highlightElementChilds(hasHighlight ? el.firstElementChild : el, Android.color());
        } else {
            var hasHighlight = false;
            if (el.firstElementChild != null && el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl]) {
                hasHighlight = true;
                el.firstElementChild.setAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl, "");
                delete el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl];
            }
            highlightElementChilds(hasHighlight ? el.firstElementChild : el , el[com.paragon.C.props._prefix + com.paragon.C.props.bg]);
            delete el[com.paragon.C.props._prefix + com.paragon.C.props.bg];
       }
    }
    function highlightElementChilds(el, color) {
        if (el.firstElementChild == null) {
            el.style.setProperty(com.paragon.C.css.background_color, color, null);
        } else {
            el = el.firstElementChild;
            do {
                el.style.setProperty(com.paragon.C.css.background_color, color, null);
            } while ((el = el.nextElementSibling) != null);
        }
    }

    function detectClickableElement(el) {
        do {
            if (el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick)
                || el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.cref)) return el;
        } while ((el = el.parentNode) != document.documentElement);
        return null;
    }
    function detectSpanElement(el) {
        do {
            if (el.tagName.toLowerCase() == 'span' && el.getAttribute("class") != null && !el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.spec)) return el;
        } while ((el = el.parentNode) != document.documentElement);
        return null;
    }

}
//
new com.paragon.event.EventProcessor().listen(true);
//

function MyShowHide(headId, bodyId) {
    var el = document.getElementById(bodyId);
    el.style.display = el.style.display == "none" ? "" : "none";
    if (el.style.display != "none")
        window.setTimeout(window.scrollTo, 100, 0, findPos(document.getElementById(headId)).y-5); 
}
function findShowHide(ev) {
	var el_node = ev.target;
	while (new String(el_node.id).indexOf('hide-head') == -1 && el_node.parentNode) {
	    el_node= el_node.parentNode;
	}
	if (new String(el_node.id).indexOf('hide-head') != -1) {
		MyShowHide(el_node.attributes['hide-head-id'].value,el_node.attributes['hide-body-id'].value);
	}
}

function scrollToFirstHighLight() {
    if (document.body[com.paragon.C.props._prefix + com.paragon.C.props.is_auto_scrolled_first_time]) return;
    document.body[com.paragon.C.props._prefix + com.paragon.C.props.is_auto_scrolled_first_time] = true;
    if (document.body.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label) && document.getElementById(document.body.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label)) != null) {
        window.location = "#" + document.body.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label);
    } else {
        var el = null;
        if (document.querySelector instanceof Function) {
            el = document.querySelector("*[" + com.paragon.C.attr._prefix + com.paragon.C.attr.hl + "]");
        } else {
            var els = document.getElementsByTagName("span");
            for (var i=0; i<els.length; i++) {
                if (els[i].hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl)) {
                    el = els[i];
                    break;
                }
            }
        }
        if (el != null)
            window.scrollTo(0,findPos(el).y);
    }
}
function scrollToTop(){
	window.scrollTo(0,0);
}
function scrollToPosition(pos) {
	window.scrollTo(0,pos);
}
function findPos(obj) {
	var curleft = 0;
    var curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return { x: curleft, y: curtop};
}

function isSkeletonBlock(block) {
	var blockLabel = block.getAttribute("shdd-label");
	return (blockLabel == "abbr") || (blockLabel == "gram_skeleton");
}

function ShowBlocks() {
    var blocks = document.getElementsByName("hideblock");
    for (var i = 0; i < blocks.length; i++)
        blocks[i].style.display = isSkeletonBlock(blocks[i]) ? "none": "";
}

function HideBlocks() {
    var blocks = document.getElementsByName("hideblock");
    for (var i = 0; i < blocks.length; i++)
        blocks[i].style.display = isSkeletonBlock(blocks[i]) ? "" : "none";
}

function getTextContentExceptScript(element) {
    var text= [];
    for (var i= 0, n= element.childNodes.length; i<n; i++) {
        var child= element.childNodes[i];
        if (child.nodeType===1 && child.tagName.toLowerCase()!=='script')
            text.push(getTextContentExceptScript(child));
        else if (child.nodeType===3)
            text.push(child.data);
    }
    return text.join('');
}

function SwitchBlocks(persist, savedState) {
    var blocks = document.getElementsByName("switchblock");
    var states = [];
    try {
        states = JSON.parse(savedState)
    } catch(err) {
        states = []
        savedState = undefined
    }

    for (var i = 0; i < blocks.length; i++) {
        var thematic = blocks[i].getAttribute("shdd-thematic");
        if (states == undefined || states[thematic] == undefined) {
            states[thematic] = SwitchBlock(blocks[i]);
        } else {
            RestoreSwitchState(blocks[i], states[thematic]);
        }
    }
    Android.onSwitchState(JSON.stringify(states), persist)
}

function GetSwitchStates(block) {
    var children = block.children;
    var states = [];
    for (var i = 0; i < children.length; i++) {
        if (children[i].getAttribute("name") == "switchstate") {
            states.push(children[i]);
        }
    }
    return states;
}

function RestoreSwitchState(block, currentState) {
    var states = GetSwitchStates(block);
    for (var i = 0; i < states.length; i++) {
        if (i == currentState) {
            states[i].style.display = "";
        } else {
            states[i].style.display = "none";
        }
    }
    return currentState;
}

function SwitchBlock(block) {
    var states = GetSwitchStates(block);
    var current = 0;
    for (var i = 0; i < states.length; i++) {
        if (states[i].style.display != "none") {
            current = i;
            states[i].style.display = "none";
            break;
        }
    }
    if (current == states.length - 1) {
        current = 0;
    } else {
        current += 1;
    }
    states[current].style.display = "";
    return current;
}

